# Aerospike Receiver

<!-- status autogenerated section -->
| Status                   |           |
| ------------------------ |-----------|
| Stability                | [alpha]   |
| Supported pipeline types | metrics   |
| Distributions            | [contrib] |

[alpha]: https://github.com/open-telemetry/opentelemetry-collector#alpha
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
<!-- end autogenerated section -->

The Aerospike receiver is designed to collect performance metrics from one or
more Aerospike nodes. It uses the
[official Go client](https://github.com/aerospike/aerospike-client-go/tree/v5/)
to connect and collect.

Aerospike versions 4.9, 5.x, and 6.x are supported.


## Configuration

Configuration parameters:

- `endpoint` (default localhost:3000): Aerospike host ex: 127.0.0.1:3000.
- `tlsname` Endpoint tls name. Used by the client during TLS connections. See [Aerospike authentication](https://docs.aerospike.com/server/guide/security/tls#standard-authentication) for mor details.
- `collect_cluster_metrics` (default false): Whether discovered peer nodes should be collected.
- `collection_interval` (default = 60s): This receiver collects metrics on an interval. Valid time units are ns, us (or µs), ms, s, m, h.
- `username` (Enterprise Edition only.)
- `password` (Enterprise Edition only.)
- `tls` (default empty/no tls) tls configuration for connection to Aerospike nodes. More information at [OpenTelemetry's tls config page](https://github.com/open-telemetry/opentelemetry-collector/blob/main/config/configtls/README.md).

### Example Configuration

```yaml
receivers:
    aerospike:
        endpoint: "localhost:3000"
        tlsname: ""
        collect_cluster_metrics: false
        collection_interval: 30s
```

## Metrics

Details about the metrics produced by this receiver can be found in [metadata.yaml](./metadata.yaml)
