// Copyright  OpenTelemetry Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package testutils // import "github.com/open-telemetry/opentelemetry-collector-contrib/receiver/awscontainerinsightreceiver/internal/cadvisor/testutils"

type MockECSInfo struct {
	ClusterName string
	InstanceIP  string
}

func (e *MockECSInfo) GetRunningTaskCount() int64 {
	return 2
}

func (e *MockECSInfo) GetCPUReserved() int64 {
	return 32
}

func (e *MockECSInfo) GetMemReserved() int64 {
	return 213
}

func (e *MockECSInfo) GetContainerInstanceID() string {
	return "eeee12.dsfr"
}

func (e *MockECSInfo) GetClusterName() string {
	return "ecs-cluster"
}
