# SSH Check Receiver

| Status                   |           |
| ------------------------ |-----------|
| Stability                | [in development] |
| Supported pipeline types | metrics   |
| Distributions            | [contrib] |

This receiver creates stats by connecting to an SSH server which may be an SFTP server.

## Prerequisites

If `ignore_host_key` is not set then host key validation requires the agent either have a known_hosts file at a path specified by setting `known_hosts` or at default paths indicated by ssh man pages: $HOME/.ssh/known_hosts or /etc/ssh/known_hosts.

## Configuration

The following settings are required:
- `endpoint`
- `username`
- `password` or `keyfile`

Either `password` or `keyfile` must be set. But if both are set then password is treated as the `passphrase` and the key is assumed to be encrypted.

The following settings are optional:

- `collection_interval` (default = `60s`): This receiver collects metrics on an interval. Valid time units are `ns`, `us` (or `µs`), `ms`, `s`, `m`, `h`.
- `known_hosts` (default = ssh defaults): The path to the known_hosts file. If this isn't set then default locations are checked at `$HOME/.ssh/known_hosts` and `/etc/ssh/known_hosts`.
- `ignore_host_key` (default = false): Can override conventional ssh security for use cases like tests where authentication via the known_hosts file isn't required.

### Example Configuration

```yaml
receivers:
  sshcheck:
    endpoint: localhost:2222
    username: otelu
    password: $OTELP
    collection_interval: 60s
```

The full list of settings exposed for this receiver are documented [here](./config.go) with detailed sample configurations [here](./testdata/config.yaml). 

## Metrics

Details about the metrics produced by this receiver can be found in [metadata.yaml](./metadata.yaml)

[beta]: https://github.com/open-telemetry/opentelemetry-collector#beta
[contrib]: https://github.com/open-telemetry/opentelemetry-collector-releases/tree/main/distributions/otelcol-contrib
